<!--
  - Copyright (C) 2020-2023 The Hunter2 Contributors.
  -
  - This file is part of Hunter2.
  -
  - Hunter2 is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free
  - Software Foundation, either version 3 of the License, or (at your option) any later version.
  -
  - Hunter2 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  - PARTICULAR PURPOSE.  See the GNU Affero General Public License for more details.
  -
  - You should have received a copy of the GNU Affero General Public License along with Hunter2.  If not, see <http://www.gnu.org/licenses/>.
  -->
<template>
  <div class="admin-guess-list">
    <div id="controls" class="d-flex flex-row">
      <p>
        <a href="?" @click.prevent="clearFilters">Clear filters</a>
      </p>
      <p>
        <input id="auto-update" v-model="autoUpdate" type="checkbox">
        <label for="auto-update">Update automatically</label>
      </p>
    </div>

    <table class="table table-small table-striped">
      <thead>
        <tr>
          <th scope="col">
            Episode
          </th>
          <th scope="col">
            Puzzle
          </th>
          <th scope="col">
            User
          </th>
          <th scope="col">
            Team
          </th>
          <th v-if="seating" scope="col">
            Seat
          </th>
          <th scope="col">
            Guess
          </th>
          <th scope="col">
            Given
          </th>
          <th scope="col">
            Time On Puzzle
          </th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="guess in guesses"
          :key="guess.id"
          :class="{ 'table-success': guess.correct, 'table-info': guess.unlocked && !guess.correct }"
        >
          <td>
            <a
              :href="`?episode=${guess.episode.id}`"
              @click.prevent="addFilter('episode', guess.episode.id)"
            >{{ guess.episode.name }}</a>
          </td>
          <td>
            <a
              :href="`?puzzle=${guess.puzzle.id}`"
              @click.prevent="addFilter('puzzle', guess.puzzle.id)"
            >{{ guess.puzzle.title }}</a>
            <span class="shortcuts">(
              <a :href="guess.puzzle.admin_url">E</a>
              <a :href="guess.puzzle.site_url">V</a>
              )</span>
          </td>
          <td>
            <a
              :href="`?user=${guess.user.id}`"
              @click.prevent="addFilter('user', guess.user.id)"
            >{{ guess.user.name }}</a>
          </td>
          <td>
            <a
              v-if="guess.team.name"
              :href="`?team=${guess.team.id}`"
              @click.prevent="addFilter('team', guess.team.id)"
            >{{ guess.team.name }}</a>
            <span v-if="!guess.team.name">none</span>
            <span class="shortcuts">(
              <a class="team-admin-view" :href="guess.team_admin_view">
                <img src="../../../hunter2/img/eye.svg" alt="View team progress">
              </a>
              )</span>
          </td>
          <td v-if="seating">
            {{ guess.user.seat }}
          </td>
          <td>
            {{ guess.guess }}
            <span class="shortcuts">(
              <a :href="guess.add_answer_url">A</a>
              <a :href="guess.add_unlock_url">U</a>
              )</span>
          </td>
          <td>
            <human-datetime :value="guess.given" />
          </td>
          <td>
            <human-duration :value="guess.time_on_puzzle" />
          </td>
        </tr>
      </tbody>
    </table>
    <el-pagination
      :page-size="perPage"
      :total="rows"
      :current-page="currentPage"
      @current-change="changePage"
    />
  </div>
</template>
<script>
import { ElPagination } from 'element-plus'
import URI from 'urijs'

import HumanDateTime from '../human-datetime.vue'
import HumanDuration from '../human-duration.vue'

export default {
  components: {
    'el-pagination': ElPagination,
    'human-datetime': HumanDateTime,
    'human-duration': HumanDuration,
  },
  props: {
    href: {
      type: String,
      required: true,
    },
    perPage: {
      default: 50,
      type: Number,
    },
  },
  data: function() {
    let search = URI(window.location).search(true)
    let page = 'page' in search ? search.page : 1
    delete search.page
    return {
      autoUpdate: true,
      currentPage: page,
      filter: search,
      guesses: [],
      rows: 0,
      seating: false,
    }
  },
  watch: {
    autoUpdate: function(on) {
      if (on) {
        this.updateData()
      }
    },
  },
  created: function() {
    this.updateData(true)
  },
  methods: {
    changePage: function(page) {
      this.autoUpdate = page === 1
      this.currentPage = page
      let new_uri = URI(window.location)
      if (page == 1) {
        new_uri.removeSearch('page')
      } else {
        new_uri.setSearch('page', page)
      }
      window.history.pushState('', '', new_uri)
      this.updateData(true)
    },
    addFilter: function(type, value) {
      this.filter[type] = value
      this.currentPage = 1
      let new_uri = URI(window.location).setSearch(type, value).removeSearch('page')
      window.history.pushState('', '', new_uri)
      this.updateData(true)
    },
    clearFilters: function() {
      this.autoUpdate = true
      this.currentPage = 1
      this.filter = {}
      let new_uri = URI(window.location).search({})
      window.history.pushState('', '', new_uri)
      this.updateData(true)
    },
    updateData: function(force) {
      clearTimeout(this.timer)
      let page = this.currentPage
      if (force || this.autoUpdate) {
        let guesses_url = URI(this.href).search({...this.filter, 'page': page})
        let v = this
        fetch(guesses_url).then(
          response => response.json(),
        ).then(
          data => {
            v.guesses = data.guesses
            v.rows = data.rows
            v.seating = data.seating
          },
        )
        if (this.autoUpdate) {
          this.timer = setTimeout(this.updateData, 5000)
        }
      }
    },
  },
}
</script>
<style lang="scss" scoped>
div#controls {
    > p {
        flex-grow: 1;
    }
}

span.shortcuts {
    @extend %nowrap;
    font-size: 75%;

    > a {
        font-weight: bold;
    }
}

span.team {
    @extend %nowrap;
}

%nowrap {
     white-space: nowrap;
 }

.team-admin-view img {
    vertical-align: baseline;
    width: 0.8rem;
    opacity: 70%;
}
</style>
